## clasp 2.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(clasp)

add_subdirectory(libclasp)
add_subdirectory(libprogram_opts)
add_subdirectory(app)

## clasp 2.0.1

=== debian/changelog ===
clasp (2.0.1-1ubuntu1) oneiric; urgency=low

  * Use LIBS instead of LDFLAGS for linking to libraries. Fixes FTBFS with ld's
    --as-needed

 -- Stefano Rivera <stefanor@ubuntu.com>  Wed, 22 Jun 2011 11:25:09 +0200

clasp (2.0.1-1) unstable; urgency=low

  * New upstream release.
  * control: Bump Standards-Version to 3.9.2.
  * patches/clasp-istreameof.patch,patches/clasp-rpath.patch: Remove.
  
 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 27 Apr 2011 10:50:10 +0200

clasp (2.0.0-3) unstable; urgency=low

  * patches/clasp-istreameof.patch: Fix unsigned conversion bug. (Closes:
    #623850)
  * control: Conditionally Build-Depends on libtbb-dev, it is only
    available on amd64,i386,ia64,ppc64.
  * patches/clasp-makefile.patch: Allow for non-multithreading builds and
    install clasp.
  * rules: Check for linux amd64,i386,ia64,ppc64 and invoke make accourdingly.
  * install: Remove as we cannot know where we are going to build upfront.
  * watch: Fix lintian debian-watch-contains-dh_make-template.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 23 Apr 2011 12:30:18 +0200

clasp (2.0.0-2) unstable; urgency=low

  * Upload to Debian. (Closes: #623599)

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 21 Apr 2011 20:24:41 +0200

clasp (2.0.0-1~maverick1) maverick; urgency=low

  * New upstream release.
  * patches/clasp-makefile.patch: Refreshed for multi-threading support.
  * patches/clasp-rpath.patch: Fix lintian error binary-or-shlib-defines-rpath.
  * control: Build-Depends on libtbb-dev.
  * install: Install MT binary.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 21 Apr 2011 19:35:27 +0200

clasp (1.3.8-1~maverick1) maverick; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 21 Apr 2011 18:55:09 +0200

clasp (1.3.7-2) unstable; urgency=low

  * copyright: Convert to DEP-5 format and add missing licenses.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 28 Feb 2011 17:44:55 +0100

clasp (1.3.7-1~maverick1) maverick; urgency=low

  * New upstream version.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 17 Feb 2011 08:20:03 +0100

clasp (1.3.6-3) unstable; urgency=low

  * Filed ITP. (Closes: #605877)

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 05 Dec 2010 17:56:39 +0100

clasp (1.3.6-2) unstable; urgency=low

  * Upload to mentors.debian.net.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 20 Nov 2010 09:25:52 +0100

clasp (1.3.6-1~maverick1) maverick; urgency=low

  * New upstream version.
  * Fix copyright information.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 19 Nov 2010 21:42:10 +0100

clasp (1.3.5-3~maverick1) maverick; urgency=low

  * Add dirs and install file.
  * Bump Priority back to extra.
  * Fix Build-Depends.
  * Add override_dh_installchangelogs to rules.
  * Remove README.source.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 20 Oct 2010 06:31:54 +0200

clasp (1.3.5-2~maverick1) maverick; urgency=low

  * Tag distro-series.

  * Fix Standards-Version and Priority.
  
  * Suggest potassco-guide.

  * Fix missing changelog.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 09 Oct 2010 16:15:39 +0200

clasp (1.3.5-1) lucid; urgency=low

  * New upstream version.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 26 Sep 2010 17:41:30 +0200

clasp (1.3.4-1) lucid; urgency=low

  * New upstream version.

  * Add claspre support.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 16 Jun 2010 11:58:47 +0200

clasp (1.3.3-4) lucid; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format.

  * Recommend gringo.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 05 Jun 2010 07:36:19 +0200

clasp (1.3.3-3) lucid; urgency=low

  * Added watch file.

  * Added Vcs-Bzr to control.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 01 Jun 2010 14:46:07 +0200

clasp (1.3.3-2) lucid; urgency=low

  * Moved to Ubuntu PPA.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 26 May 2010 00:15:33 +0200

clasp (1.3.3-1) unstable; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 09 Apr 2010 05:43:57 +0200

clasp (1.3.2-2) unstable; urgency=low

  * Added gringo to Suggests.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 06 Mar 2010 11:18:26 +0100

clasp (1.3.2-1) unstable; urgency=low

  * Initial release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 04 Mar 2010 19:31:51 +0100

=== debian/control ===
Source: clasp
Section: interpreters
Priority: extra
Maintainer: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
Build-Depends: debhelper (>= 7.0.50~),
 libtbb-dev [amd64 i386 ia64 ppc64]
Standards-Version: 3.9.2
Vcs-Bzr: https://code.launchpad.net/~tkren/+junk/asp/
Homepage: http://www.cs.uni-potsdam.de/clasp/

Package: clasp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gringo
Suggests: potassco-guide
Description: conflict-driven nogood learning answer set solver
 clasp is an answer set solver for (extended) normal logic
 programs. It combines the high-level modeling capacities of answer
 set programming (ASP) with state-of-the-art techniques from the area
 of Boolean constraint solving. The primary clasp algorithm relies on
 conflict-driven nogood learning, a technique that proved very
 successful for satisfiability checking (SAT). Unlike other learning
 ASP solvers, clasp does not rely on legacy software, such as a SAT
 solver or any other existing ASP solver. Rather, clasp has been
 genuinely developed for answer set solving based on conflict-driven
 nogood learning. clasp can be applied as an ASP solver (on LPARSE
 output format), as a SAT solver (on simplified DIMACS/CNF format), or
 as a PB solver (on OPB format).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# compile with libtbb-dev on linux intel/ppc architectures
arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep "(amd64|i386|ia64|ppc64)")
os = $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS | grep linux)

with_tbb := no
ifeq ($(and $(if $(os),good), $(if $(arch),good)), good)
	with_tbb := yes
endif


%:
	dh $@

# add WITH_TBB as parameter to make
override_dh_auto_build:
	dh_auto_build -- WITH_TBB=$(with_tbb)

# add WITH_TBB as parameter to make install
override_dh_auto_install:
	dh_auto_install -- WITH_TBB=$(with_tbb)

# install CHANGES as changelog
override_dh_installchangelogs:
	dh_installchangelogs CHANGES

## clasp 2.0.2

=== debian/changelog ===
clasp (2.0.2-1) unstable; urgency=low

  * New upstream release.
  * patches/clasp-ld-as-needed.patch: Remove.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 01 Jul 2011 05:25:39 +0200

clasp (2.0.1-2) unstable; urgency=low

  * control: Setup as Debian Science project.
    - Set Maintainer to Debian Science Maintainers and Uploaders to Thomas
      Krennwallner.
    - Set DM-Upload-Allowed to yes.
    - Convert bzr repository to git and use Vcs-Git and Vcs-Browser
    accourdingly.
  * patches/clasp-ld-as-needed.patch: Bug fix: "FTBFS with ld
    --as-needed", thanks to stefanor@debian.org; (Closes: #631270).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 22 Jun 2011 19:44:48 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,14 @@
 Source: clasp
 Section: interpreters
 Priority: extra
-Maintainer: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
+DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 7.0.50~),
  libtbb-dev [amd64 i386 ia64 ppc64]
 Standards-Version: 3.9.2
-Vcs-Bzr: https://code.launchpad.net/~tkren/+junk/asp/
+Vcs-Git: git://git.debian.org/git/debian-science/packages/clasp.git
+Vcs-Browser: http://git.debian.org/?p=debian-science/packages/clasp.git
 Homepage: http://www.cs.uni-potsdam.de/clasp/
 
 Package: clasp

## clasp 2.0.3

=== debian/changelog ===
clasp (2.0.3-3) unstable; urgency=low

  * debian/control: Do not Build-Depends on libtbb-dev with i386, see
    http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=642248.
  * debian/copyright: Fix obsolete-field-in-dep5-copyright and
    unversioned-copyright-format-uri lintian warnings.
  * debian/rules: Only set WITH_TBB for amd64, ia64, ppc64.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 25 Sep 2011 21:05:22 +0200

clasp (2.0.3-2) unstable; urgency=low

  * Bug fixed with new upstream release: "Segfaults with --pre argument
    upon certain input", thanks to Joachim Breitner (Closes: #636772).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 28 Aug 2011 08:09:00 +0200

clasp (2.0.3-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright: Fix year.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 24 Aug 2011 10:12:53 +0200

clasp (2.0.2-1ubuntu1~oneiric1) oneiric; urgency=low

  * Upload to ppa:~tkren/asp.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 01 Jul 2011 06:49:46 +0200

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 7.0.50~),
- libtbb-dev [amd64 i386 ia64 ppc64]
+Build-Depends: debhelper (>= 8.0.0),
+ libtbb-dev [amd64 ia64 ppc64]
 Standards-Version: 3.9.2
 Vcs-Git: git://git.debian.org/git/debian-science/packages/clasp.git
 Vcs-Browser: http://git.debian.org/?p=debian-science/packages/clasp.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# compile with libtbb-dev only with linux 64bit intel/ppc architectures,
# fallback in pentium4 processors is not implemented, see also note of
# libtbb-dev:
#
# Note: if you are a user of the i386 architecture, i.e., 32-bit Intel
# or compatible hardware, this package only supports Pentium4-compatible
# and higher processors.
#
arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep "(amd64|ia64|ppc64)")
os = $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS | grep linux)

with_tbb := no
ifeq ($(and $(if $(os),good), $(if $(arch),good)), good)
	with_tbb := yes
endif


%:
	dh $@

# add WITH_TBB as parameter to make
override_dh_auto_build:
	dh_auto_build -- WITH_TBB=$(with_tbb)

# add WITH_TBB as parameter to make install
override_dh_auto_install:
	dh_auto_install -- WITH_TBB=$(with_tbb)

# install CHANGES as changelog
override_dh_installchangelogs:
	dh_installchangelogs CHANGES

## clasp 2.0.4

=== debian/changelog ===
clasp (2.0.4-1) unstable; urgency=low

  * New upstream release.
  * debian/rules: Override all standard targets.
  * debian/patches/clasp-makefile.patch: Remove.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 29 Nov 2011 18:29:33 +0100

clasp (2.0.3-4ubuntu1~oneiric1) oneiric; urgency=low

  * Upload to ppa:~tkren/asp.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 18 Oct 2011 13:04:50 +0200

clasp (2.0.3-4) unstable; urgency=low

  * debian/control: Build-Depends on libtbb-dev >= 3.0+r018, version 2.2
    is not supported.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 17 Oct 2011 07:52:01 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 8.0.0),
- libtbb-dev [amd64 ia64 ppc64]
+ libtbb-dev (>= 3.0+r018) [amd64 ia64 ppc64]
 Standards-Version: 3.9.2
 Vcs-Git: git://git.debian.org/git/debian-science/packages/clasp.git
 Vcs-Browser: http://git.debian.org/?p=debian-science/packages/clasp.git

=== debian/rules ===
--- 
+++ 
@@ -15,22 +15,32 @@
 arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep "(amd64|ia64|ppc64)")
 os = $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS | grep linux)
 
-with_tbb := no
+CONFIGPARMS = --prefix=/usr --with-claspre
+TOPBUILDDIR = build/release
 ifeq ($(and $(if $(os),good), $(if $(arch),good)), good)
-	with_tbb := yes
+	CONFIGPARMS += --with-mt TBB_INCLUDE=/usr/include TBB_LIB=/usr/lib
+	TOPBUILDDIR = build/release_mt
 endif
 
 
 %:
 	dh $@
 
-# add WITH_TBB as parameter to make
+# call ./configure.sh $(CONFIGPARMS)
+override_dh_auto_configure:
+	./configure.sh $(CONFIGPARMS)
+
+# build in $(TOPBUILDDIR)
 override_dh_auto_build:
-	dh_auto_build -- WITH_TBB=$(with_tbb)
+	dh_auto_build --builddirectory=$(TOPBUILDDIR)
 
-# add WITH_TBB as parameter to make install
+# install clasp binary built in $(TOPBUILDDIR)
 override_dh_auto_install:
-	dh_auto_install -- WITH_TBB=$(with_tbb)
+	dh_auto_install --builddirectory=$(TOPBUILDDIR) -- INSTALL_DIR=$(CURDIR)/debian/clasp/usr/bin
+
+# remove the whole build dir
+override_dh_auto_clean:
+	rm -rf ./build
 
 # install CHANGES as changelog
 override_dh_installchangelogs:

## clasp 2.0.5

=== debian/changelog ===
clasp (2.0.5-1) unstable; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 29 Jan 2012 20:27:04 +0100

## clasp 2.0.6

=== debian/changelog ===
clasp (2.0.6-2) unstable; urgency=low

  * Team upload
  * Apply patch to FTBFS with gcc-4.7, thanks to Ilya Barygin (Closes: #674184)

 -- Dmitrijs Ledkovs <xnox@debian.org>  Sun, 27 May 2012 15:41:47 +0100

clasp (2.0.6-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Bump Standards-Version to 3.9.3.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 04 Apr 2012 06:35:31 +0200

clasp (2.0.5-1ubuntu1~oneiric2) oneiric; urgency=low

  * Upload to ppa:~tkren/asp.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 10 Feb 2012 09:01:57 +0100

clasp (2.0.4-1ubuntu1~oneiric1) oneiric; urgency=low

  * Upload to ppa:~tkren/asp.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 30 Nov 2011 06:36:04 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 8.0.0),
  libtbb-dev (>= 3.0+r018) [amd64 ia64 ppc64]
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Vcs-Git: git://git.debian.org/git/debian-science/packages/clasp.git
 Vcs-Browser: http://git.debian.org/?p=debian-science/packages/clasp.git
 Homepage: http://www.cs.uni-potsdam.de/clasp/

## clasp 2.1.0

=== debian/changelog ===
clasp (2.1.0-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright: Fix Format URL.
  * debian/rules: Add hardening support.
  * debian/gcc-4.7.patch: Remove unnecessary patch.
  * debian/control: Bump Standards-Version to 3.9.3.1 and Build-Depends on
    dephelper >= 9.
  * debian/compat: Bump to 9.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 27 Aug 2012 20:20:04 +0200

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,10 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 8.0.0),
+Build-Depends: debhelper (>= 9),
+ dpkg-dev (>= 1.16.1~),
  libtbb-dev (>= 3.0+r018) [amd64 ia64 ppc64]
-Standards-Version: 3.9.3
+Standards-Version: 3.9.3.1
 Vcs-Git: git://git.debian.org/git/debian-science/packages/clasp.git
 Vcs-Browser: http://git.debian.org/?p=debian-science/packages/clasp.git
 Homepage: http://www.cs.uni-potsdam.de/clasp/

=== debian/rules ===
--- 
+++ 
@@ -15,20 +15,35 @@
 arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep "(amd64|ia64|ppc64)")
 os = $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS | grep linux)
 
+# use hardening config flags for compiling clasp
+CONFIG=hardening
 CONFIGPARMS = --prefix=/usr --with-claspre
-TOPBUILDDIR = build/release
+TOPBUILDDIR = build/$(CONFIG)
 ifeq ($(and $(if $(os),good), $(if $(arch),good)), good)
 	CONFIGPARMS += --with-mt TBB_INCLUDE=/usr/include TBB_LIB=/usr/lib
-	TOPBUILDDIR = build/release_mt
+	TOPBUILDDIR = build/$(CONFIG)_mt
 endif
 
+#
+# export CXXFLAGS and LDFLAGS for configure.sh
+#
+# add -O3 and NDEBUG and enable all hardening flags
+#
+DEB_CXXFLAGS_MAINT_APPEND = -O3 -DNDEBUG
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
+
+# inject CPPFLAGS to CXXFLAGS
+CXXFLAGS += $(CPPFLAGS)
 
 %:
 	dh $@
 
 # call ./configure.sh $(CONFIGPARMS)
 override_dh_auto_configure:
-	./configure.sh $(CONFIGPARMS)
+	./configure.sh --config=$(CONFIG) $(CONFIGPARMS)
 
 # build in $(TOPBUILDDIR)
 override_dh_auto_build:

## clasp 2.1.1

=== debian/changelog ===
clasp (2.1.1-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Bump Standards-Version to 3.9.4 and Build-Depends on
    libtbb-dev >= 4.0+r233.
  * debian/copyright: Update copyright years.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 28 Nov 2012 10:35:53 +0100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 9),
  dpkg-dev (>= 1.16.1~),
- libtbb-dev (>= 3.0+r018) [amd64 ia64 ppc64]
-Standards-Version: 3.9.3.1
+ libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64]
+Standards-Version: 3.9.4
 Vcs-Git: git://git.debian.org/git/debian-science/packages/clasp.git
 Vcs-Browser: http://git.debian.org/?p=debian-science/packages/clasp.git
 Homepage: http://www.cs.uni-potsdam.de/clasp/

## clasp 2.1.3

=== debian/changelog ===
clasp (2.1.3-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright: Update copyright years.
  * debian/control: Remove DM-Upload-Allowed.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 21 May 2013 09:22:08 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: extra
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
-DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 9),
  dpkg-dev (>= 1.16.1~),
  libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64]

## clasp 2.1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

project(clasp)
add_definitions( -DWITH_THREADS=0 )
add_subdirectory(libclasp)
add_subdirectory(libprogram_opts)
add_subdirectory(app)

=== app/CMakeLists.txt ===
file(GLOB APP_SRC *.cpp)
include_directories(${CMAKE_SOURCE_DIR}/libclasp ${CMAKE_SOURCE_DIR}/libprogram_opts)
add_executable(clasp_app ${APP_SRC})
target_link_libraries(clasp_app libclasp libprogram_opts)
set_target_properties(clasp_app PROPERTIES OUTPUT_NAME clasp)
SET( EXECUTABLE_OUTPUT_PATH  ${CMAKE_BINARY_DIR}/bin)

=== libprogram_opts/Makefile ===
SHELL        ?= /bin/sh
AR           ?= ar
CXX          ?= g++
BUILD_DIR    ?= .
ROOT_DIR     ?= .
CXXFLAGS     ?= -O3 -DNDEBUG
FLAGS        ?= 
ifneq ($(FLAGS),)
-include $(FLAGS)
endif
INCLUDE      := -I $(ROOT_DIR) 
ALL_CXXFLAGS := -W -Wall $(INCLUDE) $(CXXFLAGS) 
TARGET       := $(BUILD_DIR)/lib/libprogram_opts.a
SOURCES      := $(patsubst $(ROOT_DIR)/src/%.cpp,%.cpp,$(wildcard $(ROOT_DIR)/src/*.cpp))
DEPS         := $(patsubst %.cpp,$(BUILD_DIR)/%.dep, $(SOURCES))
OBJECTS      := $(patsubst %.cpp,$(BUILD_DIR)/%.o, $(SOURCES))
vpath %.cpp $(ROOT_DIR)/src
vpath %.h   $(ROOT_DIR)/program_opts

$(TARGET):	$(FLAGS) $(DEPS) $(OBJECTS)
	$(AR)  cvrs $(TARGET) $(OBJECTS)


ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

$(BUILD_DIR)/%.dep: %.cpp $(FLAGS)
	$(CXX) $(ALL_CXXFLAGS) -MT $(BUILD_DIR)/$*.o -MM $< > $@

$(BUILD_DIR)/%.o: %.cpp $(FLAGS)
	$(CXX) $(ALL_CXXFLAGS) -c $< -o $@


.PHONY:	clean 

ifeq ($(findstring Windows,$(OS)),)
clean:
	@$(RM) $(TARGET)
	@$(RM) $(OBJECTS)
	@$(RM) $(DEPS)
else
RM := del /F /Q
clean:
	@$(RM) $(subst /,\,$(TARGET))  2>nul
	@$(RM) $(subst /,\,$(OBJECTS)) 2>nul
	@$(RM) $(subst /,\,$(DEPS))    2>nul
endif

=== libclasp/example/Makefile ===
SHELL        ?= /bin/sh
AR           ?= ar
CXX          ?= g++
BUILD_DIR    ?= .
ROOT_DIR     ?= ..
CXXFLAGS     ?= -O3 -DNDEBUG
FLAGS        ?=
LIBS         ?= $(ROOT_DIR)/lib/libclasp.a
ifneq ($(FLAGS),)
-include $(FLAGS)
endif
INCLUDE      := -I $(ROOT_DIR) 
ALL_CXXFLAGS := -W -Wall $(INCLUDE) $(CXXFLAGS) 
TARGET       := $(BUILD_DIR)/example
SOURCES      := $(patsubst $(ROOT_DIR)/example/%.cpp,%.cpp,$(wildcard $(ROOT_DIR)/example/*.cpp))
DEPS         := $(patsubst %.cpp,$(BUILD_DIR)/%.dep, $(SOURCES))
OBJECTS      := $(patsubst %.cpp,$(BUILD_DIR)/%.o, $(SOURCES))
vpath %.cpp $(ROOT_DIR)/example
vpath %.h   $(ROOT_DIR)/example

$(TARGET):  $(FLAGS) $(LIBS) $(DEPS) $(OBJECTS)
	$(CXX) $(WARNFLAGS) $(CXXFLAGS) $(LDFLAGS) $(OBJECTS) $(LIBS) -o $(TARGET)

$(LIBS):
	$(MAKE) -C $(ROOT_DIR) "BUILD_DIR=lib"

ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

$(BUILD_DIR)/%.dep: %.cpp $(FLAGS)
	$(CXX) $(ALL_CXXFLAGS) -MT $(BUILD_DIR)/$*.o -MM $< > $@

$(BUILD_DIR)/%.o: %.cpp $(FLAGS)
	$(CXX) $(ALL_CXXFLAGS) -c $< -o $@


.PHONY:	clean 
ifeq ($(findstring Windows,$(OS)),)
clean:
	@$(RM) $(TARGET)
	@$(RM) $(OBJECTS)
	@$(RM) $(DEPS)
else
RM := del /F /Q
clean:
	@$(RM) $(subst /,\,$(TARGET))  2>nul
	@$(RM) $(subst /,\,$(OBJECTS)) 2>nul
	@$(RM) $(subst /,\,$(DEPS))    2>nul
endif

=== debian/changelog ===
clasp (2.1.4-1ubuntu1) trusty; urgency=medium

  * Match the whole line in dpkg-architecture -qDEB_BUILD_ARCH check, to
    avoid getting confused by substrings.
  * Use TBB on ppc64el.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 24 Mar 2014 16:37:20 +0000

clasp (2.1.4-1) unstable; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Fri, 13 Dec 2013 11:44:18 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: clasp
 Section: interpreters
 Priority: extra
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 Build-Depends: debhelper (>= 9),
  dpkg-dev (>= 1.16.1~),
- libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64]
+ libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64 ppc64el]
 Standards-Version: 3.9.4
 Vcs-Git: git://git.debian.org/git/debian-science/packages/clasp.git
 Vcs-Browser: http://git.debian.org/?p=debian-science/packages/clasp.git

=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,7 @@
 # or compatible hardware, this package only supports Pentium4-compatible
 # and higher processors.
 #
-arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep "(amd64|ia64|ppc64)")
+arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep -x "(amd64|ia64|ppc64|ppc64el)")
 os = $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS | grep linux)
 
 # use hardening config flags for compiling clasp

=== debian/watch ===
# watch control file for uscan

# Compulsory line, this is a version 3 file
version=3

# qa.debian.org runs a redirector which allows a simpler form of URL
# for SourceForge based projects. The format below will automatically
# be rewritten to use the redirector.
http://sf.net/potassco/clasp-([\d\.]+)-source\.tar\.gz

## clasp 3.0.6

=== libclasp/CMakeLists.txt ===
file(GLOB LIBCLASP_SRC src/*.cpp)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR}/lib)
add_library(libclasp STATIC ${LIBCLASP_SRC})

=== debian/changelog ===
clasp (3.0.6-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Fix Vcs fields to use anonscm.debian.org.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 07 Aug 2014 11:53:54 +0200

clasp (3.0.5-1) unstable; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 19 May 2014 17:48:23 +0200

clasp (3.0.4-1) unstable; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 24 Apr 2014 11:26:44 +0200

clasp (3.0.3-1) unstable; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 30 Mar 2014 07:34:40 +0200

clasp (3.0.2-2) unstable; urgency=low

  * Bug fix: "fix up TBB handling for ppc64el", thanks to Colin Watson
    (Closes: #742514).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 25 Mar 2014 07:27:42 +0100

clasp (3.0.2-1) unstable; urgency=low

  * New upstream release.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 17 Mar 2014 17:11:58 +0100

clasp (3.0.1-1) unstable; urgency=low

  * New upstream release.
  * Bug fix: "3.0 cannot solve some problems solved by 2.1.4", thanks to
    Julian Andres Klode (Closes: #739628).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 25 Feb 2014 17:04:16 +0100

clasp (3.0.0-1) unstable; urgency=low

  * New upstream release.
  * debian/rules: Call configure.sh without --with-claspre.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 16 Feb 2014 11:19:35 +0100

clasp (2.1.5-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Bump Standards-Version to 3.9.5.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 11 Feb 2014 12:37:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: clasp
 Section: interpreters
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 Build-Depends: debhelper (>= 9),
  dpkg-dev (>= 1.16.1~),
  libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64 ppc64el]
-Standards-Version: 3.9.4
-Vcs-Git: git://git.debian.org/git/debian-science/packages/clasp.git
-Vcs-Browser: http://git.debian.org/?p=debian-science/packages/clasp.git
+Standards-Version: 3.9.5
+Vcs-Git: git://anonscm.debian.org/debian-science/packages/clasp.git
+Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/clasp.git
 Homepage: http://www.cs.uni-potsdam.de/clasp/
 
 Package: clasp

## clasp 3.1.0

=== debian/changelog ===
clasp (3.1.0-1) unstable; urgency=low

  * New upstream release.
  * debian/control: Remove Suggests on potassco-guide
  * Setup git repository to use git-buildpackage.
  * Import upstream sources with git-import-orig --pristine-tar --uscan.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 18 Aug 2014 13:00:07 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,6 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: gringo
-Suggests: potassco-guide
 Description: conflict-driven nogood learning answer set solver
  clasp is an answer set solver for (extended) normal logic
  programs. It combines the high-level modeling capacities of answer

## clasp 3.1.1

=== debian/changelog ===
clasp (3.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 3.9.6.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 26 Nov 2014 08:44:17 +0100

## clasp 3.1.2

=== debian/changelog ===
clasp (3.1.2-1) unstable; urgency=medium

  * Imported Upstream version 3.1.2
  * Fix dep5-copyright-license-name-not-unique and
    missing-license-paragraph-in-dep5-copyright lintian warnings.

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Tue, 12 May 2015 07:18:25 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper (>= 9),
  dpkg-dev (>= 1.16.1~),
  libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64 ppc64el]
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/clasp.git
 Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/clasp.git
 Homepage: http://www.cs.uni-potsdam.de/clasp/

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,7 @@
 
 # use hardening config flags for compiling clasp
 CONFIG=hardening
-CONFIGPARMS = --prefix=/usr --with-claspre
+CONFIGPARMS = --prefix=/usr
 TOPBUILDDIR = build/$(CONFIG)
 ifeq ($(and $(if $(os),good), $(if $(arch),good)), good)
 	CONFIGPARMS += --with-mt TBB_INCLUDE=/usr/include TBB_LIB=/usr/lib

## clasp 3.1.3

=== debian/changelog ===
clasp (3.1.3-2) unstable; urgency=medium

  * Circumvent g++-5 loop code generation bug.
  * Bug fix: "aspcud fails to find solution if optimization criteria are
    passed for some problems", thanks to Johannes Schauer (Closes:
    #800526).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Mon, 05 Oct 2015 07:43:55 +0200

clasp (3.1.3-1) unstable; urgency=medium

  * Imported Upstream version 3.1.3
  * debian/control: Add pkg-config (>= 0.28) to Build-Depends
  * debian/rules: Use pkg-config to get libdir / includedir of tbb: fixes
    "FTBFS: Error: TBB library path not set or 'libtbb.{so,dylib}' not
    found!", thanks to Chris Lamb (Closes: #799989).

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 26 Sep 2015 08:57:05 +0200

## clasp 3.1.4

=== libclasp/Makefile ===
SHELL        ?= /bin/sh
AR           ?= ar
CXX          ?= g++
ROOT_DIR     ?= .
TARGET_DIR   ?= $(ROOT_DIR)/lib
BUILD_DIR    ?= $(ROOT_DIR)/lib
CXXFLAGS     ?= -O3 -DNDEBUG
FLAGS        ?=
ifneq ($(FLAGS),)
-include $(FLAGS)
endif
INCLUDE      := -I $(ROOT_DIR) 
ALL_CXXFLAGS := -W -Wall $(INCLUDE) $(CXXFLAGS) 
TARGET       := $(TARGET_DIR)/libclasp.a
SOURCES      := $(patsubst $(ROOT_DIR)/src/%.cpp,%.cpp,$(wildcard $(ROOT_DIR)/src/*.cpp))
DEPS         := $(patsubst %.cpp,$(BUILD_DIR)/%.dep, $(SOURCES))
OBJECTS      := $(patsubst %.cpp,$(BUILD_DIR)/%.o, $(SOURCES))
vpath %.cpp $(ROOT_DIR)/src
vpath %.h   $(ROOT_DIR)/clasp

$(TARGET):	$(FLAGS) $(DEPS) $(OBJECTS)
	$(AR)  cvrs $(TARGET) $(OBJECTS)


ifneq ($(MAKECMDGOALS),clean)
-include $(DEPS)
endif

$(BUILD_DIR)/%.dep: %.cpp $(FLAGS)
	$(CXX) $(ALL_CXXFLAGS) -MT $(BUILD_DIR)/$*.o -MM $< > $@

$(BUILD_DIR)/%.o: %.cpp $(FLAGS)
	$(CXX) $(ALL_CXXFLAGS) -c $< -o $@


.PHONY:	clean 
ifeq ($(findstring Windows,$(OS)),)
clean:
	@$(RM) $(TARGET)
	@$(RM) $(OBJECTS)
	@$(RM) $(DEPS)
else
RM := del /F /Q
clean:
	@$(RM) $(subst /,\,$(TARGET))  2>nul
	@$(RM) $(subst /,\,$(OBJECTS)) 2>nul
	@$(RM) $(subst /,\,$(DEPS))    2>nul
endif

=== libprogram_opts/CMakeLists.txt ===
file(GLOB LIBOPTS_SRC src/*.cpp)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR}/lib)
add_library(libprogram_opts STATIC ${LIBOPTS_SRC})

=== libclasp/tests/Makefile ===
SHELL = /bin/sh
CXX = g++
CXXFLAGS = 
INCLUDE = -I../ -I.
ALL_CXXFLAGS = $(INCLUDE) $(CXXFLAGS)
TARGET = clasp_test
CPPUNIT_INCLUDE:=~/cppunit-1.12.1/include
CPPUNIT_LIB:=~/cppunit-1.12.1/lib/libcppunit.a
clasp_lib:=../lib/libclasp.a
sources:=$(wildcard *.cpp)
objects:=$(patsubst %.cpp,%.o,$(sources))
deps:=$(patsubst %.cpp,%.dep,$(sources))

$(TARGET):	$(clasp_lib) $(objects) $(deps)
	$(CXX) $(ALL_CXXFLAGS) $(objects) $(clasp_lib) $(CPPUNIT_LIB) -o $(TARGET)

ifneq ($(MAKECMDGOALS),clean)
  ifneq ($(MAKECMDGOALS),distclean)
    -include $(deps)
  endif
endif

%.o:	%.cpp
	$(CXX) $(ALL_CXXFLAGS) -I $(CPPUNIT_INCLUDE) -c $< -o $@

%.dep: %.cpp
	$(CXX) $(INCLUDE) -I $(CPPUNIT_INCLUDE) -MM $< > $@

$(clasp_lib):
	$(MAKE)  -C ../src

.PHONY:	clean distclean
clean:
	@$(RM) $(TARGET)
	@$(RM) $(objects)
	@$(RM) $(deps)

distclean: clean

=== debian/changelog ===
clasp (3.1.4-1) unstable; urgency=medium

  * Imported Upstream version 3.1.4
  * Remove g++5 patch introduced in clasp 3.1.3-2
  * Fix dep5-copyright-license-name-not-unique

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 20 Dec 2015 12:06:30 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,8 @@
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 Build-Depends: debhelper (>= 9),
  dpkg-dev (>= 1.16.1~),
- libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64 ppc64el]
+ libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64 ppc64el],
+ pkg-config (>= 0.28)
 Standards-Version: 3.9.6
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/clasp.git
 Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/clasp.git

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,9 @@
 CONFIGPARMS = --prefix=/usr
 TOPBUILDDIR = build/$(CONFIG)
 ifeq ($(and $(if $(os),good), $(if $(arch),good)), good)
-	CONFIGPARMS += --with-mt TBB_INCLUDE=/usr/include TBB_LIB=/usr/lib
+	TBBINCLUDEDIR=$(shell pkg-config --variable=includedir tbb)
+	TBBLIBDIR=$(shell pkg-config --variable=libdir tbb)
+	CONFIGPARMS += --with-mt TBB_INCLUDE=$(TBBINCLUDEDIR) TBB_LIB=$(TBBLIBDIR)
 	TOPBUILDDIR = build/$(CONFIG)_mt
 endif

## clasp 3.1.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/tools")
project(clasp)
include(CheckIncludeFileCXX)
find_package(TBB)
include_directories (libclasp libprogram_opts)

if(NOT TBB_FOUND)
	MESSAGE (STATUS "TBB not found. Building without threads.")
	add_definitions( -DWITH_THREADS=0 )
else(NOT TBB_FOUND)
	MESSAGE (STATUS "TBB found. Building with threads.")
	add_definitions( -DWITH_THREADS=1 )
	link_directories(${TBB_LIBRARY_DIRS})
endif(NOT TBB_FOUND)

add_subdirectory(libclasp)
add_subdirectory(libprogram_opts)
add_subdirectory(app)

check_include_file_cxx("cppunit/Test.h" has_cpp_unit)
if (has_cpp_unit)
	enable_testing ()
	file(GLOB LIBCLASP_TEST libclasp/tests/*.cpp)
	add_definitions(-DWITH_TEST_CLI)
	add_executable(claspTest ${LIBCLASP_TEST})
	target_link_libraries(claspTest libclasp libprogram_opts cppunit)
	if(TBB_FOUND)
		target_link_libraries(claspTest tbb)
	endif()
	add_test (NAME ClaspTest COMMAND claspTest)
else()
	message(STATUS "cppunit not found - skipping tests")
endif()

=== debian/changelog ===
clasp (3.1.5-1ubuntu1) yakkety; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/rules: Cope with multiarch libtbb.

 -- Logan Rosen <logan@ubuntu.com>  Mon, 05 Sep 2016 02:30:09 -0400

clasp (3.1.5-1) unstable; urgency=medium

  * New upstream version 3.1.5
  * debian/rules: cope with multiarch libtbb, thanks to Steve Beattie
  * Remove parallel solve patch introduced in clasp 3.1.4-2
  * Bug fix: "please make the build reproducible", thanks to Reiner
    Herrmann (Closes: #828971)

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 04 Sep 2016 09:54:27 +0200

clasp (3.1.4-2ubuntu1) yakkety; urgency=medium

  * debian/rules: cope with multiarch libtbb

 -- Steve Beattie <sbeattie@ubuntu.com>  Mon, 02 May 2016 22:40:37 -0700

clasp (3.1.4-2) unstable; urgency=medium

  * Add patch to fix wrong number of optimal models in parallel mode
    (upstream bug 116)
  * Bump Standards-Version to 3.9.8

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sun, 01 May 2016 08:51:17 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: clasp
 Section: interpreters
 Priority: extra
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 Build-Depends: debhelper (>= 9),
  dpkg-dev (>= 1.16.1~),
  libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64 ppc64el],
  pkg-config (>= 0.28)
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/clasp.git
 Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/clasp.git
 Homepage: http://www.cs.uni-potsdam.de/clasp/

=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,7 @@
 #
 arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep -x "(amd64|ia64|ppc64|ppc64el)")
 os = $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS | grep linux)
+multiarch=$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)
 
 # use hardening config flags for compiling clasp
 CONFIG=hardening
@@ -21,7 +22,7 @@
 TOPBUILDDIR = build/$(CONFIG)
 ifeq ($(and $(if $(os),good), $(if $(arch),good)), good)
 	TBBINCLUDEDIR=$(shell pkg-config --variable=includedir tbb)
-	TBBLIBDIR=$(shell pkg-config --variable=libdir tbb)
+	TBBLIBDIR=$(shell pkg-config --variable=libdir tbb)/$(multiarch)
 	CONFIGPARMS += --with-mt TBB_INCLUDE=$(TBBINCLUDEDIR) TBB_LIB=$(TBBLIBDIR)
 	TOPBUILDDIR = build/$(CONFIG)_mt
 endif

## clasp 3.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/tools")
include(CheckCXXCompilerFlag)
include(CheckCXXSourceCompiles)
include(CheckIncludeFileCXX)
project(clasp)

if (NOT CMAKE_BUILD_TYPE)
	message(STATUS "No build type selected, using 'Release'")
	set(CMAKE_BUILD_TYPE "Release")
endif()

# clasp control variables
set (CLASP_COMPILE_DEFS "")
set (CLASP_LINK_LIBS "")
set (CLASP_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/liblp" "${CMAKE_CURRENT_SOURCE_DIR}/libprogram_opts")
option(WITH_THREADS "Try to build with thread support" ON)


if (WITH_THREADS)
	file(READ ${CMAKE_CURRENT_SOURCE_DIR}/tools/has_std_thread.cpp thread_test)
	check_cxx_compiler_flag("-std=c++11" has_cxx11_flag)
	if (has_cxx11_flag)
		SET(CMAKE_REQUIRED_FLAGS "-std=c++11")
	endif()
	check_cxx_source_compiles("${thread_test}" has_std_threads)
	if (has_std_threads)
		find_package (Threads)
		MESSAGE (STATUS "Building with std threads (link: ${CMAKE_THREAD_LIBS_INIT})")
		SET(CLASP_LINK_LIBS ${CMAKE_THREAD_LIBS_INIT})
		SET(CLASP_COMPILE_DEFS -DWITH_THREADS=1 -DCLASP_USE_STD_THREAD)
		if (has_cxx11_flag)
			add_definitions( -std=c++11 )
		endif()
	else()
		find_package(TBB)
		if (TBB_FOUND)
			MESSAGE (STATUS "TBB found. Building with tbb threads.")
			SET(CLASP_COMPILE_DEFS -DWITH_THREADS=1)
			SET(CLASP_LINK_LIBS ${TBB_LIBRARIES})
			SET(CLASP_INCLUDE_DIRS ${CLASP_INCLUDE_DIRS} ${TBB_INCLUDE_DIRS})
			link_directories(${TBB_LIBRARY_DIRS})
		else()
			MESSAGE (STATUS "Building without threads.")
			set (CLASP_COMPILE_DEFS -DWITH_THREADS=0)
		endif()
	endif()
else()
	set (CLASP_COMPILE_DEFS -DWITH_THREADS=0)
endif()

message(STATUS "debug flags  :${CMAKE_CXX_FLAGS_DEBUG}")
message(STATUS "release flags:${CMAKE_CXX_FLAGS_RELEASE}")
message(STATUS "clasp flags  :${CLASP_COMPILE_DEFS}")
message(STATUS "clasp libs   :${CLASP_LINK_LIBS}")
message(STATUS "clasp include:${CLASP_INCLUDE_DIRS}")
add_subdirectory(liblp)
add_subdirectory(libprogram_opts)
add_subdirectory(libclasp)
add_subdirectory(app)

check_include_file_cxx("cppunit/Test.h" has_cpp_unit)
if (has_cpp_unit)
	find_library(has_cpp_unit cppunit)
endif()
if (has_cpp_unit)
	enable_testing ()
	file(GLOB LIBCLASP_TEST libclasp/tests/*.cpp)
	include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libclasp ${CLASP_INCLUDE_DIRS})
	add_definitions(${CLASP_COMPILE_DEFS})
	add_executable(claspTest ${LIBCLASP_TEST})
	target_link_libraries(claspTest clasp lp program_opts cppunit ${CLASP_LINK_LIBS})
	add_test (NAME ClaspTest COMMAND claspTest)
else()
	message(STATUS "cppunit not found - skipping tests")
endif()

=== app/CMakeLists.txt ===
file(GLOB CLASP_APP_SRC *.cpp)
include_directories(${CMAKE_SOURCE_DIR}/libclasp ${CMAKE_SOURCE_DIR}/liblp ${CMAKE_SOURCE_DIR}/libprogram_opts)
add_definitions(${CLASP_COMPILE_DEFS})
add_executable(clasp_app ${CLASP_APP_SRC})
target_link_libraries(clasp_app clasp lp program_opts ${CLASP_LINK_LIBS})
set_target_properties(clasp_app PROPERTIES OUTPUT_NAME clasp)
SET( EXECUTABLE_OUTPUT_PATH  ${CMAKE_BINARY_DIR}/bin)

file(GLOB LPCONVERT_SRC lpconvert/*.cpp)
add_executable(lpconvert ${LPCONVERT_SRC})
target_link_libraries(lpconvert lp program_opts)

=== libclasp/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
file(GLOB LIBCLASP_SRC src/*.cpp)
if (NOT CLASP_INCLUDE_DIRS)
	set(CLASP_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/../liblp" "${CMAKE_CURRENT_SOURCE_DIR}/../libprogram_opts")
endif()
if (NOT CLASP_COMPILE_DEFS)
	set (CLASP_COMPILE_DEFS "-DWITH_THREADS=0")
endif()
include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CLASP_INCLUDE_DIRS})
add_definitions(${CLASP_COMPILE_DEFS})

SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR}/lib)
add_library(clasp STATIC ${LIBCLASP_SRC})

# Doc target
find_package(Doxygen)
if(DOXYGEN_FOUND)
	set(doxyfile ${CMAKE_CURRENT_SOURCE_DIR}/doc/api/clasp)
	add_custom_target(doc
		COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile}
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc/api 
		COMMENT "Generating clasp documentation..."
		VERBATIM)
endif()

=== liblp/CMakeLists.txt ===
file(GLOB LIBLP_SRC src/*.cpp)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR}/lib)
add_library(lp STATIC ${LIBLP_SRC})
enable_testing ()
add_test (NAME LpTest COMMAND lpTest)
file(GLOB LIBLP_TEST tests/*.cpp)
if(NOT MSVC)
	add_definitions (-std=c++11)
endif()
add_executable (lpTest ${LIBLP_TEST})
target_link_libraries(lpTest lp)

=== libprogram_opts/CMakeLists.txt ===
file(GLOB LIBOPTS_SRC src/*.cpp)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR}/lib)
add_library(program_opts STATIC ${LIBOPTS_SRC})

=== debian/changelog ===
clasp (3.2.1-3) unstable; urgency=medium

  * debian/rules: enable threads on all archs, use LDFLAGS to inject
    -latomic on archs that need it
  * fix FTBFS on alpha: do not define FPU_SWITCH_DOUBLE on alpha,
    _FPU_GETCW and friends are undefined on this arch

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 17 Dec 2016 07:55:33 +0100

clasp (3.2.1-2) unstable; urgency=medium

  * debian/rules: disable threads on powerpc,powerpcspe,m68k,mips,mipsel
  * debian/control: use https

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Sat, 03 Dec 2016 11:06:00 +0100

clasp (3.2.1-1) unstable; urgency=medium

  * New upstream version 3.2.1
  * watch clasp releases on github
  * debian/copyright: update copyright year and github source
  * debian/control
    - Build-Depends on g++ >= 4:6.1.1 replaces libtbb-dev
    - point Homepage to http://www.potassco.org
  * debian/rules: drop libtbb-dev and use c++11 multi-threading
  * clasp-manpage.patch: point to http://www.potassco.org/clasp

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Thu, 01 Dec 2016 08:22:07 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,16 @@
 Source: clasp
 Section: interpreters
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Krennwallner <tkren@kr.tuwien.ac.at>
 Build-Depends: debhelper (>= 9),
  dpkg-dev (>= 1.16.1~),
- libtbb-dev (>= 4.0+r233) [amd64 ia64 ppc64 ppc64el],
+ g++ (>= 4:6.1.1),
  pkg-config (>= 0.28)
 Standards-Version: 3.9.8
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/clasp.git
-Vcs-Browser: http://anonscm.debian.org/cgit/debian-science/packages/clasp.git
-Homepage: http://www.cs.uni-potsdam.de/clasp/
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/clasp.git
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/clasp.git
+Homepage: https://www.potassco.org/clasp/
 
 Package: clasp
 Architecture: any

=== debian/watch ===
# watch control file for uscan

# Compulsory line, this is a version 3 file
version=3

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/clasp-$1\.tar\.gz/ \
  https://github.com/potassco/clasp/tags .*/v?(\d\S+)\.tar\.gz

## clasp 3.2.2

=== debian/changelog ===
clasp (3.2.2-1) unstable; urgency=medium

  * New upstream version 3.2.2
  * drop clasp-alpha-fpu-getcw.patch, already applied upstream

 -- Thomas Krennwallner <tkren@kr.tuwien.ac.at>  Wed, 01 Feb 2017 11:52:16 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# clasp requires c++11 threads with 64bit __atomic_exchange, we need to
# link with libatomic on powerpc, powerpcspe, m68k, mips, mipsel, and
# sh4, see also
# https://gcc.gnu.org/wiki/Atomic
# https://gcc.gnu.org/wiki/Atomic/GCCMM/LIbrary
arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep -x "(powerpc|powerpcspe|m68k|mips|mipsel|sh4)")

# use custom hardening config flags for compiling clasp
CONFIG=hardening
CONFIGPARMS = --prefix=/usr --with-mt=std
TOPBUILDDIR = build/$(CONFIG)_mt

#
# export CXXFLAGS and LDFLAGS for configure.sh
#
# add -O3 and NDEBUG and enable all hardening flags
# link with libatomic on architectures without built-in atomic
#
DEB_CXXFLAGS_MAINT_APPEND = -O3 -DNDEBUG
DEB_LDFLAGS_MAINT_APPEND =
ifeq ($(if $(arch),atomic), atomic)
	DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# inject CPPFLAGS to CXXFLAGS
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@

# call ./configure.sh $(CONFIGPARMS)
override_dh_auto_configure:
	./configure.sh --config=$(CONFIG) $(CONFIGPARMS)

# build in $(TOPBUILDDIR)
override_dh_auto_build:
	dh_auto_build --builddirectory=$(TOPBUILDDIR)

# install clasp binary built in $(TOPBUILDDIR)
override_dh_auto_install:
	dh_auto_install --builddirectory=$(TOPBUILDDIR) -- INSTALL_DIR=$(CURDIR)/debian/clasp/usr/bin

# remove the whole build dir
override_dh_auto_clean:
	rm -rf ./build

# install CHANGES as changelog
override_dh_installchangelogs:
	dh_installchangelogs CHANGES
